﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml;
using System.Xml.Linq;

namespace LinqDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            //#region Linq to objects 对比
            //Console.WriteLine("使用老方法来对集合对象查询，查询结果为：");
            //OldQuery();
            //Console.WriteLine("使用Linq方法来对集合对象查询，查询结果为：");
            //LinqQuery();
            //Console.Read();
            ////Console.WriteLine("按下Enter进入Linq to XML 的比较");
            //#endregion

            #region Linq to XML 对比
            Console.WriteLine("使用XPath来对XML文件查询，查询结果为：");
            OldLinqToXMLQuery();
            Console.WriteLine("使用Linq方法来对XML文件查询，查询结果为：");
            UsingLinqLinqtoXMLQuery();
            Console.ReadKey();
            #endregion

            #region Linq to SQL对比
            #endregion
        }

        #region Linq to Objects对比

        // 使用Linq 和使用Foreach语句的对比

        // 1. 使用foreach返回集合中序号为偶数的元素
        private static void OldQuery()
        {
            // 初始化查询的数据
            List<string> collection = new List<string>();
            for (int i = 0; i < 10; i++)
            {
                collection.Add("A"+i.ToString());
            }
          
            // 创建保存查询结果的集合
            List<string> queryResults = new List<string>();
            foreach (string s in collection)
            {
                // 获取元素序号
                int index = int.Parse(s.Substring(1));
                // 查询序号为偶数的元素
                if (index % 2 == 0)
                {
                    queryResults.Add(s);
                }
            }

            // 输出查询结果
            foreach (string s in queryResults)
            {
                Console.WriteLine(s);
            }
        }

        // 2. 使用Linq返回集合中序号为偶数的元素
        private static void LinqQuery()
        {
            // 初始化查询的数据
            List<string> collection = new List<string>();
            for (int i = 0; i < 10; i++)
            {
                collection.Add("A" + i.ToString());
            }

            // 创建查询表达式来获得序号为偶数的元素
            var queryResults = from s in collection
                               let index = int.Parse(s.Substring(1))
                               where index % 2 == 0
                               select s;
            // 输出查询结果
            foreach (string s in queryResults)
            {
                Console.WriteLine(s);
            }
        }
        #endregion

        #region Linq to XML 对比
    
        // 初始化XML数据
        private static string xmlString = 
            "<Persons>"+
            "<Person Id='1'>"+
            "<Name>张三</Name>"+
            "<Age>18</Age>"+
            "</Person>" +
            "<Person Id='2'>"+
            "<Name>李四</Name>"+
            "<Age>19</Age>"+
            "</Person>"+
             "<Person Id='3'>" +
            "<Name>王五</Name>" +
            "<Age>22</Age>" +
            "</Person>"+
            "</Persons>";

        // 使用XPath方式来对XML文件进行查询
        private static void OldLinqToXMLQuery()
        {
            // 导入XML文件
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.LoadXml(xmlString);

            // 创建查询XML文件的XPath
            string xPath = "/Persons/Person";

            // 查询Person元素
            XmlNodeList querynodes = xmlDoc.SelectNodes(xPath);
            foreach (XmlNode node in querynodes)
            {
                // 查询名字为李四的元素
                foreach (XmlNode childnode in node.ChildNodes)
                {
                    if (childnode.InnerXml == "李四")
                    {
                        Console.WriteLine("姓名为： "+childnode.InnerXml + "  Id 为：" + node.Attributes["Id"].Value);
                    }
                }
            }

        }

        // 使用Linq 来对XML文件进行查询
        private static void UsingLinqLinqtoXMLQuery()
        {
            // 导入XML
            XElement xmlDoc = XElement.Parse(xmlString);

            // 创建查询，获取姓名为“李四”的元素
            var queryResults = from element in xmlDoc.Elements("Person")
                               where element.Element("Name").Value == "李四"
                               select element;
           
            // 输出查询结果
            foreach (var xele in queryResults)
            {
                Console.WriteLine("姓名为： " + xele.Element("Name").Value + "  Id 为：" + xele.Attribute("Id").Value);
            }
        }
        #endregion

        #region Linq to SQL 对比

        #endregion 
    }
}
